diff --git a/onmainwindow.cpp b/onmainwindow.cpp
index c9741f8..f973014 100644
--- a/onmainwindow.cpp
+++ b/onmainwindow.cpp
@@ -8775,7 +8990,9 @@ void ONMainWindow::slotCheckXOrgConnection()
         }
         else
         {
-            x2goDebug<<"waiting for X";
+
+            x2goDebug<<"...waiting for X.";
+
             QTimer::singleShot(1000, this, SLOT(slotCheckXOrgConnection()));
         }
     }
@@ -8805,7 +9022,8 @@ void WinServerStarter::run()
 
 void ONMainWindow::startWinServers()
 {
-    x2goDebug<<"Starting win servers"<<endl;
+
+    x2goDebug<<"Starting win servers...";
 
     QString etcDir=homeDir+"/.x2go/etc";
     QDir dr ( homeDir );
@@ -8833,7 +9051,9 @@ void ONMainWindow::startWinServers()
         startPulsed();
     }
 // #ifdef CFGCLIENT
-//     x2goDebug<<"xorg settings: "<<startXorgOnStart <<" "<< useXming<<endl;
+
+    x2goDebug<<"Xorg settings: "<< startXorgOnStart <<" useXming: "<< useXming;
+
     if ( useInternalX && (internalX== XMING))
     {
 // #endif
@@ -8880,23 +9100,29 @@ void ONMainWindow::saveCygnusSettings()
     {
         if ( haveCySolEntry() )
         {
-            x2goDebug<<"Cygnus Solutions entry exist";
+
+            x2goDebug<<"Cygnus Solutions entry exists.";
+
             cySolEntry=true;
         }
         else
         {
             cySolEntry=false;
-            x2goDebug<<"Cygnus Solutions entry not exist";
+
+            x2goDebug<<"Cygnus Solutions entry not exist.";
+
         }
 
         if ( haveCygwinEntry() )
         {
-            x2goDebug<<"Cygwin entry exist";
+
+            x2goDebug<<"Cygwin entry exist.";
+
             cyEntry=true;
         }
         else
         {
-            x2goDebug<<"Cygwin entry not exist";
+            x2goDebug<<"Cygwin entry not exist.";
             cyEntry=false;
         }
     }
@@ -8906,7 +9132,9 @@ void ONMainWindow::saveCygnusSettings()
                       QSettings::NativeFormat );
     oldEtcDir=QString::null;
     oldEtcDir=etcst.value ( "native",oldEtcDir ).toString();
-    x2goDebug<<"old etc:"<<oldEtcDir<<endl;
+
+    x2goDebug<<"Old etc: "<<oldEtcDir;
+
     QString newEtc=homeDir+"/.x2go/etc";
     QDir d ( newEtc );
     if ( !d.exists() )
@@ -8915,31 +9143,40 @@ void ONMainWindow::saveCygnusSettings()
 
     etcst.setValue ( "native",wapiShortFileName ( newEtc ) );
     etcst.sync();
-    x2goDebug<<"new etc:"<<wapiShortFileName ( newEtc ) <<endl;
+
+    x2goDebug<<"New etc: "<<wapiShortFileName ( newEtc );
+
 
     QSettings binst ( "HKEY_CURRENT_USER\\Software"
                       "\\Cygnus Solutions\\Cygwin\\mounts v2\\/bin",
                       QSettings::NativeFormat );
     oldBinDir=QString::null;
     oldBinDir=binst.value ( "native",oldBinDir ).toString();
-    x2goDebug<<"old bin:"<<oldBinDir<<endl;
+
+    x2goDebug<<"Old bin: "<<oldBinDir;
+
     QString newBin=appDir;
     newBin.replace ( "/","\\" );
     binst.setValue ( "native",wapiShortFileName ( newBin ) );
     binst.sync();
-    x2goDebug<<"new bin:"<<newBin<<endl;
+
+    x2goDebug<<"New bin: "<<newBin;
 
     QSettings tmpst ( "HKEY_CURRENT_USER\\Software"
                       "\\Cygnus Solutions\\Cygwin\\mounts v2\\/tmp",
                       QSettings::NativeFormat );
     oldTmpDir=QString::null;
     oldTmpDir=tmpst.value ( "native",oldTmpDir ).toString();
-    x2goDebug<<"old tmp:"<<oldTmpDir<<endl;
+
+    x2goDebug<<"Old tmp: "<<oldTmpDir;
+
     QString newTmp=QDir::tempPath();
     newTmp.replace ( "/","\\" );
     tmpst.setValue ( "native",wapiShortFileName ( newTmp ) );
     tmpst.sync();
-    x2goDebug<<"new tmp:"<<newTmp<<endl;
+
+    x2goDebug<<"New tmp: "<<newTmp;
+
 }
 
 void ONMainWindow::restoreCygnusSettings()
@@ -8950,7 +9187,9 @@ void ONMainWindow::restoreCygnusSettings()
         QSettings st ( "HKEY_CURRENT_USER\\Software"
                        "\\Cygnus Solutions\\Cygwin\\mounts v2\\/etc",
                        QSettings::NativeFormat );
-        x2goDebug<<"Removing /etc from cygwin mounts\n";
+
+        x2goDebug<<"Removing /etc from cygwin mounts.";
+
         st.remove ( "" );
         st.sync();
     }
@@ -8961,14 +9200,18 @@ void ONMainWindow::restoreCygnusSettings()
                        QSettings::NativeFormat );
         st.setValue ( "native",oldEtcDir );
         st.sync();
-        x2goDebug<<"Restoring /etc in cygwin mounts\n";
+
+        x2goDebug<<"Restoring /etc in cygwin mounts.";
+
     }
     if ( oldBinDir==QString::null )
     {
         QSettings st ( "HKEY_CURRENT_USER\\Software"
                        "\\Cygnus Solutions\\Cygwin\\mounts v2\\/bin",
                        QSettings::NativeFormat );
-        x2goDebug<<"Removing /bin from cygwin mounts\n";
+
+        x2goDebug<<"Removing /bin from cygwin mounts.";
+
         st.remove ( "" );
         st.sync();
     }
@@ -8979,14 +9222,18 @@ void ONMainWindow::restoreCygnusSettings()
                        QSettings::NativeFormat );
         st.setValue ( "native",oldBinDir );
         st.sync();
-        x2goDebug<<"Restoring /bin in cygwin mounts\n";
+
+        x2goDebug<<"Restoring /bin in cygwin mounts.";
+
     }
     if ( oldTmpDir==QString::null )
     {
         QSettings st ( "HKEY_CURRENT_USER\\Software"
                        "\\Cygnus Solutions\\Cygwin\\mounts v2\\/tmp",
                        QSettings::NativeFormat );
-        x2goDebug<<"Removing /tmp from cygwin mounts\n";
+
+        x2goDebug<<"Removing /tmp from cygwin mounts.";
+
         st.remove ( "" );
         st.sync();
     }
@@ -8997,7 +9244,9 @@ void ONMainWindow::restoreCygnusSettings()
                        QSettings::NativeFormat );
         st.setValue ( "native",oldTmpDir );
         st.sync();
-        x2goDebug<<"Restoring /tmp in cygwin mounts\n";
+
+        x2goDebug<<"Restoring /tmp in cygwin mounts.";
+
     }
     if ( ONMainWindow::portable )
     {
@@ -9017,7 +9266,8 @@ void ONMainWindow::removeCygwinEntry()
     QSettings st ( "HKEY_CURRENT_USER\\Software"
                    "\\Cygnus Solutions\\Cygwin",
                    QSettings::NativeFormat );
-    x2goDebug<<"Removing cygwin\n";
+    x2goDebug<<"Removing cygwin.";
+
     st.remove ( "" );
     st.sync();
 
@@ -9028,7 +9278,9 @@ void ONMainWindow::removeCySolEntry()
     QSettings st ( "HKEY_CURRENT_USER\\Software"
                    "\\Cygnus Solutions",
                    QSettings::NativeFormat );
-    x2goDebug<<"Removing cygnus solutions\n";
+
+    x2goDebug<<"Removing cygnus solutions.";
+
     st.remove ( "" );
     st.sync();
 }
@@ -9045,7 +9297,9 @@ void ONMainWindow::startPulsed()
     QDir dr ( homeDir );
     dr.mkpath ( pulseDir );
     pulseDir=wapiShortFileName ( pulseDir );
-    x2goDebug<<"template: "<<pulseDir+"/tmp"<<endl;
+
+    x2goDebug<<"pulse template: "<<pulseDir+"/tmp";
+
     QTemporaryFile* fl=new QTemporaryFile ( pulseDir+"/tmp" );
     fl->open();
     pulseDir=fl->fileName();
@@ -9053,7 +9307,9 @@ void ONMainWindow::startPulsed()
     delete fl;
     QFile::remove ( pulseDir );
     dr.mkpath ( pulseDir );
-    x2goDebug<<"pulse tmp file: "<<pulseDir<<endl;
+
+    x2goDebug<<"pulse tmp file: "<<pulseDir;
+
     QStringList pEnv=QProcess::systemEnvironment();
     for ( int i=0; i<pEnv.size(); ++i )
     {
@@ -9093,12 +9349,15 @@ void ONMainWindow::startPulsed()
     pulseServer->setWorkingDirectory ( wapiShortFileName (
                                            appDir+"\\pulse" ) );
     pulseServer->start ( "pulse\\pulseaudio.exe",pulseArgs );
-    x2goDebug<<"starting pulse\\pulseaudio.exe "<<pulseArgs.join ( " " ) <<
+
+    x2goDebug<<"Starting pulse\\pulseaudio.exe "<<pulseArgs.join ( " " ) <<
              " working dir: "<<
-             wapiShortFileName ( appDir+"\\pulse" ) <<endl;
+             wapiShortFileName ( appDir+"\\pulse" );
+
     pulseTimer=new QTimer(this);
-    x2goDebug<<"connect timer";
+
     connect (pulseTimer, SIGNAL(timeout()), this, SLOT(slotCheckPulse()));
+    x2goDebug<<"Connected timer.";
     pulseTimer->start(2000);
 }
 
@@ -9108,7 +9367,9 @@ void ONMainWindow::slotCheckPulse()
     if(pulseServer->state()!=QProcess::Running)
     {
         pulseServer->start ( "pulse\\pulseaudio.exe",pulseArgs );
-        x2goDebug<<"restarting pulse\\pulseaudio.exe "<<pulseArgs.join ( " " );
+
+        x2goDebug<<"Restarting pulse\\pulseaudio.exe "<<pulseArgs.join ( " " );
+
     }
 }
 
@@ -9116,7 +9377,9 @@ void ONMainWindow::slotCheckPulse()
 // #ifdef CFGCLIENT
 void ONMainWindow::xorgSettings()
 {
-    x2goDebug<<"getting xorg settings"<<endl;
+
+    x2goDebug<<"Getting Xorg settings.";
+
 
     X2goSettings st ( "settings" );
 
@@ -9151,7 +9414,9 @@ void ONMainWindow::xorgSettings()
 
 void ONMainWindow::slotSetWinServersReady()
 {
-    x2goDebug<<"all winservers are started\n";
+
+    x2goDebug<<"All winservers are started.";
+
     winServersReady=true;
     restoreCygnusSettings();
 }
@@ -9171,10 +9436,12 @@ void ONMainWindow::generateEtcFiles()
         QString sid, sys, user, grsid, grname;
         if ( !wapiAccountInfo ( &sid,&user,&grsid, &grname, &sys ) )
         {
-// 			x2goDebug<<"Get account info failed\n";
+
+            x2goDebug<<"Get account info failed.";
             close();
         }
 
+
 // 		x2goDebug<<"sid: "<<sid <<" system:"<<
 // 		sys<< " user: "<<user<<" group sid:"<<grsid<<
 // 		"group name: "<<grname<<endl;
@@ -9209,7 +9476,9 @@ void ONMainWindow::generateEtcFiles()
            <<appDir<<"/sftp-server\n";
 #endif
         file.close();
-        x2goDebug<<etcDir +"/sshd_config created";
+
+        x2goDebug<<etcDir +"/sshd_config created.";
+
 #ifdef Q_OS_WIN
     }
 #endif
@@ -9223,7 +9492,9 @@ void ONMainWindow::generateHostDsaKey()
     if ( !QFile::exists ( etcDir+"/ssh_host_dsa_key" ) ||
             !QFile::exists ( etcDir+"/ssh_host_dsa_key.pub" ) )
     {
-        /*		x2goDebug<<"Generating host DSA key\n";*/
+
+        x2goDebug<<"Generating host DSA key.";
+
 #ifdef Q_OS_WIN
         QString fname=cygwinPath ( wapiShortFileName ( etcDir ) ) +
                       "/ssh_host_dsa_key";
@@ -9262,7 +9533,9 @@ void ONMainWindow::startSshd()
     desktopName+=getenv ( "USERNAME" );
     char* desktop=new char[desktopName.size() +1];
     strcpy ( desktop,desktopName.c_str() );
-    x2goDebug<<"Creating desktop: "<<desktop<<endl;
+
+    x2goDebug<<"Creating desktop: "<<desktop;
+
     if ( !CreateDesktopA (
                 desktop,
                 0,
@@ -9273,7 +9546,9 @@ void ONMainWindow::startSshd()
             ) )
     {
         strcpy ( desktop,"" );
-        x2goDebug<<"Desktop creation failed, using default\n";
+
+        x2goDebug<<"Desktop creation failed, using default.";
+
     }
     ZeroMemory ( &si, sizeof ( si ) );
     ZeroMemory ( &sshd, sizeof ( sshd ) );
@@ -9299,7 +9574,8 @@ void ONMainWindow::startSshd()
     arguments<<"-f"<<etcDir +"/sshd_config"<< "-h" <<
              etcDir+"/ssh_host_dsa_key"<<"-D"<<"-p"<<clientSshPort;
     sshd->start ( appDir+"/sshd",arguments );
-    x2goDebug<<"Usermode sshd started";
+    x2goDebug<<"Usermode sshd started.";
+
 #endif
 }
 
@@ -9401,7 +9677,14 @@ void ONMainWindow::slotSetProxyWinFullscreen()
 void ONMainWindow::resizeProxyWinOnDisplay(int disp)
 {
     QRect geom=QApplication::desktop()->screenGeometry(disp-1);
-    //x2goDebug<<"resizing proxy win to fit display "<<disp<<"("<<geom<<")"<<endl;
+
+    QString geoStr =
+            "(x: " + QString("%1").arg(geom.x()) +
+            ", y: "+ QString("%1").arg(geom.y()) +
+            ", w: "+ QString("%1").arg(geom.width()) +
+            ", h: "+ QString("%1").arg(geom.height());
+    x2goDebug<<"Resizing proxy window to fit Display: " + QString("%1").arg(disp) + " " + geoStr;
+
 #ifdef Q_OS_LINUX
     XSync(QX11Info::display(),false);
     XMoveWindow(QX11Info::display(), proxyWinId,geom.x(),geom.y());
@@ -9444,14 +9727,21 @@ void ONMainWindow::slotConfigXinerama()
     QRect newGeometry=proxyWinGeometry();
     if (newGeometry.isNull())
     {
-//     x2goDebug<<"error getting window geometry (window closed?)\n";
+        x2goWarningf(7)<< tr("Error getting window geometry (window closed)?");
         xineramaTimer->stop();
         return;
     }
     if (newGeometry==lastDisplayGeometry)
         return;
     lastDisplayGeometry=newGeometry;
-//    x2goDebug<<"New proxy geometry: "<<lastDisplayGeometry<<endl;
+
+    QString geoStr =
+            "(x: " + QString("%1").arg(lastDisplayGeometry.x()) +
+            ", y: "+ QString("%1").arg(lastDisplayGeometry.y()) +
+            ", w: "+ QString("%1").arg(lastDisplayGeometry.width()) +
+            ", h: "+ QString("%1").arg(lastDisplayGeometry.height());
+    x2goDebug<<"New proxy geometry: " + geoStr;
+
     QDesktopWidget* root=QApplication::desktop();
     QList<QRect> newXineramaScreens;
     for (int i=0; i< root->numScreens(); ++i)
@@ -9463,17 +9753,19 @@ void ONMainWindow::slotConfigXinerama()
             intersection=root->screenGeometry(i).intersected(lastDisplayGeometry);
         if (!intersection.isNull())
         {
-//            x2goDebug<<"intersected with "<<i<<": "<<intersection<<endl;
+            //            x2goDebug<<"intersected with "<<i<<": "<<intersection<<endl;
             intersection.moveLeft(intersection.x()-lastDisplayGeometry.x());
             intersection.moveTop(intersection.y()-lastDisplayGeometry.y());
-//            x2goDebug<<"xinerama screen: "<<intersection<<endl;
+
+            //            x2goDebug<<"xinerama screen: "<<intersection<<endl;
             newXineramaScreens<<intersection;
         }
     }
     if (xineramaScreens != newXineramaScreens)
     {
         xineramaScreens=newXineramaScreens;
-//        x2goDebug<<"xinerama screen changed, new screens: "<<xineramaScreens<<endl;
+        //        x2goDebug<<"xinerama screen changed, new screens: "<<xineramaScreens<<endl;
+
         xineramaTimer->stop();
         QStringList screens;
         foreach (QRect disp, xineramaScreens)
@@ -9482,7 +9774,6 @@ void ONMainWindow::slotConfigXinerama()
         QString cmd="export DISPLAY=:"+resumingSession.display+";printf '"+screens.join("\\\\n")+"' >  ~/.x2go/C-"+
                     resumingSession.sessionId+"/xinerama.conf";
 
-        x2goDebug<<cmd<<endl;
         sshConnection->executeCommand(cmd, this, SLOT(slotXineramaConfigured()));
     }
 }
@@ -9514,12 +9805,14 @@ void ONMainWindow::slotXineramaConfigured()
 void ONMainWindow::slotFindProxyWin()
 {
 #ifndef Q_OS_DARWIN
-//     x2goDebug<<"search proxy win: "<<"X2GO-"+resumingSession.sessionId;
+    x2goDebug<<"Searching proxy win: X2GO-" + resumingSession.sessionId;
+
     proxyWinId=findWindow ( "X2GO-"+resumingSession.sessionId );
     bool xinerama=defaultXinerama;
     if ( proxyWinId )
     {
-        x2goDebug<<"proxy win found:"<<proxyWinId;
+        x2goDebug<<"Proxy win found: " + QString("%1").arg(proxyWinId);
+
         setProxyWinTitle();
         proxyWinTimer->stop();
         if (!embedMode)
@@ -9555,7 +9848,8 @@ void ONMainWindow::slotFindProxyWin()
             }
             if (xinerama)
             {
-                x2goDebug<<"Starting xinerama timer\n";
+                x2goDebug<<"Starting Xinerama Timer.";
+
                 lastDisplayGeometry=QRect();
                 xineramaScreens.clear();
                 xineramaTimer->start(500);
@@ -9564,23 +9858,26 @@ void ONMainWindow::slotFindProxyWin()
 
         if ( embedMode )
         {
-            x2goDebug<<"checking rootless config";
+            x2goDebug<<"Checking rootless config.";
+
             if ( config.rootless )
             {
-                x2goDebug<<"win is rootless";
+                x2goDebug<<"Window is rootless.";
                 act_embedContol->setEnabled ( false );
             }
             else
                 slotAttachProxyWindow();
         }
 #ifdef Q_OS_WIN
-        x2goDebug<<"maximizeProxyWin: "<<maximizeProxyWin;
+        x2goDebug<<"Maximize proxy win: "<<maximizeProxyWin;
+
         if ( !startEmbedded )
         {
             if ( maximizeProxyWin )
             {
                 QDesktopWidget dw;
-                x2goDebug<<"making proxy win full screen";
+
+                x2goDebug<<"Making proxy win full screen.";
                 wapiSetFSWindow ( ( HWND ) proxyWinId,
                                   dw.screenGeometry ( this ) );
                 /*wapiShowWindow ( ( HWND ) proxyWinId,
@@ -9621,9 +9918,8 @@ void ONMainWindow::slotDetachProxyWindow()
     //and reconnect
     if ( !embedControlChanged )
     {
-        x2goDebug<<"\n";
         slotFindProxyWin();
-        x2goDebug<<"proxy win detached, proxywin is:"<<proxyWinId<<endl;
+        x2goDebug<<"Proxy win detached, proxywin is: "<<proxyWinId;
     }
 #endif
     embedControlChanged=false;
@@ -9632,7 +9928,8 @@ void ONMainWindow::slotDetachProxyWindow()
 
 void ONMainWindow::slotAttachProxyWindow()
 {
-    x2goDebug<<"slotAttachProxy";
+    x2goDebug<<"slotAttachProxyWindow.";
+
     if ( startEmbedded )
     {
         embedControlChanged=false;
@@ -9646,7 +9943,9 @@ void ONMainWindow::slotAttachProxyWindow()
     }
     else
     {
-        x2goDebug<<"start embedded was false";
+
+        x2goDebug<<"Start embedded was false.";
+
         startEmbedded=true;
     }
 
@@ -9954,7 +10253,9 @@ void ONMainWindow::slotChangeKbdLayout(const QString& layout)
 #ifdef Q_OS_LINUX
     QStringList args;
     args<<"-layout"<<layout;
-    x2goDebug<<"running setxkbmap with params: "<<args.join(" ");
+
+    x2goDebug<<"Running setxkbmap with params: "<<args.join(" ");
+
     QProcess::startDetached("setxkbmap",args);
 #endif
 }
@@ -10727,8 +11028,10 @@ void ONMainWindow::slotActivateWindow()
         QApplication::setActiveWindow ( this ) ;
         activateWindow();
 
+
         /*		x2goDebug<<"focus:"<<pass->hasFocus();
-        		x2goDebug<<"activ:"<<pass->isActiveWindow();*/
+                x2goDebug<<"activ:"<<pass->isActiveWindow();*/
+
         QTimer::singleShot ( 50, this,
                              SLOT ( slotEmbedToolBarToolTip() ) );
     }
@@ -10876,7 +11179,6 @@ QString ONMainWindow::u3DataPath()
     QString dpath;
     for ( int i=0; i<env.size(); ++i )
     {
-// 		x2goDebug << env[i];
         //check if we have U3 System
         if ( env[i].indexOf ( "U3_APP_DATA_PATH=" ) ==0 )
         {
@@ -10912,14 +11214,18 @@ void ONMainWindow::cleanPortable()
 
 void ONMainWindow::removeDir ( QString path )
 {
-    x2goDebug<<"entering " <<path;
+
+    x2goDebug<<"removeDir, entering: " <<path;
+
     QDir dr ( path );
     QStringList files=dr.entryList ( QDir::Files );
     for ( int i=0; i<files.size(); ++i )
     {
         if ( files[i]!="known_hosts" || cleanAllFiles)
         {
-            x2goDebug<<"cleaning file:"<<path+"/"+files[i];
+
+            x2goDebug<<"Cleaning file: "<<path+"/"+files[i];
+
             dr.remove ( path+"/"+files[i] );
         }
     }
@@ -10971,6 +11277,7 @@ long ONMainWindow::X11FindWindow ( QString text, long rootWin )
 
 long ONMainWindow::findWindow ( QString text )
 {
+    x2goDebug<<"Searching window with title: " + text;
 #ifdef Q_OS_LINUX
     return X11FindWindow ( text );
 #endif
@@ -10985,7 +11292,9 @@ long ONMainWindow::findWindow ( QString text )
 void ONMainWindow::setX2goconfig ( const QString& text )
 {
     m_x2goconfig=text;
-    x2goDebug<<"have session config";
+
+    x2goDebug<<"Haveing a session config.";
+
     initWidgetsEmbed();
 }
 
@@ -10995,12 +11304,16 @@ void ONMainWindow::doPluginInit()
     Dl_info info;
     dladdr ( ( void* ) & ( ONMainWindow::getPortable ),&info );
     QString fname=info.dli_fname;
+
     x2goDebug<<"Application name:" <<fname;
+
     QString clientDir;
     QString pluginDir;
     int pos=fname.lastIndexOf ( "/" );
     pluginDir=fname.left ( pos );
-    x2goDebug<<"Plugin Dir:" <<pluginDir;
+
+    x2goDebug<<"Plugin directory: " <<pluginDir;
+
     QDir dr ( pluginDir );
     if ( dr.exists ( "x2goclient/x2goclient" ) )
     {
@@ -11026,7 +11339,9 @@ void ONMainWindow::doPluginInit()
             clientDir=pluginDir;
         }
     }
-    x2goDebug<<"Client Dir:"<<clientDir;
+
+    x2goDebug<<"Client directory: "<<clientDir;
+
     QString path=getenv ( "PATH" );
     path=clientDir+":"+pluginDir+":"+path;
     setenv ( "PATH",path.toAscii (),1 );
@@ -11102,7 +11417,9 @@ void ONMainWindow::slotUpdateEmbedWindow()
         oldContainerSize=embedContainer->size();
         oldChildPos= mapToGlobal (
                          QPoint ( 0,0 ) );
-        x2goDebug<<"updating embedded window"<<endl;
+
+        x2goDebug<<"Updating embedded window.";
+
     }
 }
 
@@ -11115,7 +11432,9 @@ void ONMainWindow::embedWindow ( long wndId )
     childId=wndId;
     embedContainer->show();
 #ifdef Q_OS_LINUX
-    x2goDebug<<"embedding "<<wndId<<" in container"<<endl;
+
+    x2goDebug<<"Embedding window with id "<<wndId<<" in container.";
+
     embedContainer->embedClient ( wndId );
 #endif
 #ifdef Q_OS_WIN
diff --git a/onmainwindow.h b/onmainwindow.h
index 5a48cba..41eeca7 100644
--- a/onmainwindow.h
+++ b/onmainwindow.h
@@ -324,6 +324,9 @@ public:
         ARTS,
         ESD
     };
+
+    static bool debugging;
+
     static bool portable;
     ONMainWindow ( QWidget *parent = 0 );
     ~ONMainWindow();
diff --git a/show_printouts.sh b/show_printouts.sh
new file mode 100755
index 0000000..3f16c24
--- /dev/null
+++ b/show_printouts.sh
@@ -0,0 +1,30 @@
+#!/bin/bash
+
+die () {
+    echo >&2 "$@"
+    exit 1
+}
+
+[ "$#" -eq 1 ] || die "You have to provide the filename to be parsed for printouts, exiting."
+
+echo "-----------------------------------------------------------------------------------------------------"
+echo "DEBUGS"
+echo "-----------------------------------------------------------------------------------------------------"
+cat -n $1 | grep 'x2goDebug'     | sed -e 's/\(^\s*[0-9]*\)[ \t\/\*]*x2goDebug\s*<<\s*\(.*\)$/\1:\t \2/'   | sed -e 's/,//g' | sort -k1n
+echo "$DEBUGS"
+
+echo "-----------------------------------------------------------------------------------------------------"
+echo "INFOS"
+echo "-----------------------------------------------------------------------------------------------------"
+cat -n $1 | grep 'x2goInfof('    | sed -e 's/\(^\s*[0-9]*\)[ \t\/\*]*x2goInfof(\([0-9]*\))\s*<<\s*\(.*\)$/\1:\t\2\t\3/'    | sed -e 's/,//g' | sort -k2n
+
+echo "-----------------------------------------------------------------------------------------------------"
+echo "WARNINGS"
+echo "-----------------------------------------------------------------------------------------------------"
+cat -n $1 | grep 'x2goWarningf(' | sed -e 's/\(^\s*[0-9]*\)[ \t\/\*]*x2goWarningf(\([0-9]*\))\s*<<\s*\(.*\)$/\1:\t\2\t\3/' | sed -e 's/,//g' | sort -k2n
+
+echo "-----------------------------------------------------------------------------------------------------"
+echo "ERRORS"
+echo "-----------------------------------------------------------------------------------------------------"
+cat -n $1 | grep 'x2goErrorf('   | sed -e 's/\(^\s*[0-9]*\)[ \t\/\*]*x2goErrorf(\([0-9]*\))\s*<<\s*\(.*\)$/\1:\t\2\t\3/'   | sed -e 's/,//g' | sort -k2n
+
